const parser = require('csv-parse/lib/sync');
const readline = require('readline');
const fs = require('fs');

const rl = readline.createInterface({
  input: process.stdin,
  output: process.stdout
})

const INPUT_DIR = "./csv/";
const OUTPUT_DIR = "./json/";

const getRows = (fileName) => {
	const path = INPUT_DIR + fileName;
	console.log("Fetching from", path);
	const contents = fs.readFileSync(path, 'utf8')	
	return parser(contents, {
	  delimiter: ";",
	  skip_empty_lines: true
	})
}

const parseRows = (header, rows) => {
	const output = {}
	header.forEach((v, i) => {
		if(v === "") return;
		output[v] = {include: [], exclude: []}
		rows.forEach((row) => {
			if(row[i] !== "") output[v].include.push(row[i]);
		})
	})
	return output;
}
const saveJson = (fileName, map) => {
	const path = OUTPUT_DIR + fileName.replace(".csv", ".json");
	console.log("Saving to", path);
	fs.writeFile(path, JSON.stringify(map, null, 2), console.error);
}

const main = () => {
	rl.question("Inserisci file di input: ", (file) => {
		const rows = getRows(file);
		console.log(rows);
		const json = rows.length == 0 ? {} : parseRows(rows[0], rows.splice(1))
		saveJson(file, json)
	});
}


main()

